on startMovie
  global gTopicList, gTitleList, gRouterName, gDemo, gButtonBase, gButtonLast, gSpriteBase, gCastBase, gGoingToTopic, gStartCtrl, gHandCursor, gDemoDir, gCD
  unLoad()
  set gRouterName to gDemoDir & "\mdroute.exe"
  set gGoingToTopic to 0
  set gButtonBase to the number of cast "hilite"
  set gButtonLast to the number of cast "wines"
  set gButtonLast to gButtonLast + 1
  set gStartCtrl to 3
  set gHandCursor to [30, 31]
  set gSpriteBase to 10
  set gCastBase to 71
  set gButtonBase to 50
  set gTopicList to field "topicList"
  set gTitleList to field "titles"
  put EMPTY into field "currentTitle"
  setPuppets(0)
  repeat with i = 1 to 12
    set vCastNum to gButtonBase + i
    set vSpriteNum to gSpriteBase + i
    set the castNum of sprite vSpriteNum to vCastNum
  end repeat
end

on stopMovie
  global gDemo, gRouterName
end

on doQuit
  global gRouterName
  set vCmd to gRouterName && "exit"
  open(vCmd)
  quit()
end

on setTopicState fState
  global gTopicState, gCurrentTopic
  if fState = gTopicState then
    exit
  end if
  set gTopicState to fState
  set vTopicScreen to gCurrentTopic & fState
  unLoad()
  go(vTopicScreen)
  updateStage()
end

on setPuppets fState
  set vLow to the puppet of sprite 1
  set vHigh to the puppet of sprite 21
  if (vHigh = fState) and (vLow = fState) then
    exit
  else
    repeat with i = 1 to 21
      puppetSprite(i, fState)
    end repeat
  end if
end

on doInstall
  global gCD, gCurrentTopic, gStr, gRouterName
  if gCurrentTopic = "gardens" then
    set gStr to gRouterName && gCD & "\MULTICOM\GARDENS\INSTALL\SETUP.EXE"
  else
    if gCurrentTopic = "parks" then
      set gStr to gRouterName && gCD & "\MULTICOM\PARKS\INSTALL\SETUP.EXE"
    else
      if gCurrentTopic = "cookbook" then
        set gStr to gRouterName && gCD & "\MULTICOM\CKBOOK\INSTALL\SETUP.EXE"
      else
        if gCurrentTopic = "astro" then
          set gStr to gRouterName && gCD & "\MULTICOM\ASTROSRC\INSTALL\SETUP.EXE"
        else
          if gCurrentTopic = "space" then
            set gStr to gRouterName && gCD & "\MULTICOM\SPACE\INSTALL\SETUP.EXE"
          else
            if gCurrentTopic = "planets" then
              set gStr to gRouterName && gCD & "\MULTICOM\PLANETS\INSTALL\SETUP.EXE"
            else
              if gCurrentTopic = "oz" then
                set gStr to gRouterName && gCD & "\MULTICOM\OZ\INSTALL\SETUP.EXE"
              else
                if gCurrentTopic = "dandy" then
                  set gStr to gRouterName && gCD & "\MULTICOM\DNDYDINO\INSTALL\SETUP.EXE"
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  set vFrameNo to the frame - 1
  go(vFrameNo)
  set vPlaceMark to " " & the frameLabel
  put vPlaceMark after gStr
  go("samplerExit")
  open(gStr)
  quit()
end

on setCtrlCursor
  global gStartCtrl, gHandCursor
  repeat with i = 1 to 5
    set vSprite to i + gStartCtrl - 1
    set the cursor of sprite vSprite to gHandCursor
  end repeat
end

on bTitleInstalled fTopic
  global gDemo
  set vTopic to strConvertName(fTopic)
  set vResult to gDemo(mGetIniEntry, "mcomdemo.ini", "applications", vTopic)
  if vResult = "yes" then
    return 1
  else
    return 0
  end if
end

on strConvertName fName
  if fName = "astro" then
    set vReturn to "astrosrc"
  else
    if fName = "cookbook" then
      set vReturn to "ckbook"
    else
      if fName = "dandy" then
        set vReturn to "dndydino"
      else
        if fName = "gardens" then
          set vReturn to "gardens"
        else
          if fName = "oz" then
            set vReturn to "oz"
          else
            if fName = "parks" then
              set vReturn to "parks"
            else
              if fName = "planets" then
                set vReturn to "planets"
              else
                if fName = "space" then
                  set vReturn to "space"
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  return vReturn
end

on strFullName fName
  if fName = "astro" then
    set vIndex to 5
  else
    if fName = "cookbook" then
      set vIndex to 3
    else
      if fName = "dandy" then
        set vIndex to 10
      else
        if fName = "gardens" then
          set vIndex to 1
        else
          if fName = "oz" then
            set vIndex to 9
          else
            if fName = "parks" then
              set vIndex to 2
            else
              if fName = "planets" then
                set vIndex to 8
              else
                if fName = "space" then
                  set vIndex to 6
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  set vLine to line vIndex of field "titles"
  return vLine
end

on doGroup fStart, fEnd, fState
  repeat with i = fStart to fEnd
    set vSave to the puppet of sprite i
    puppetSprite(i, 1)
    set the visible of sprite i to fState
    puppetSprite(i, vSave)
  end repeat
  updateStage()
end

on gotoTitle
  global gCD, gCurrentTopic, gDemoDir, gRouterName
  if gCurrentTopic = "gardens" then
    set vArg to gDemoDir & "\GARDENS\gardens.iw"
    set vProg to gDemoDir & "\present\present.exe"
  else
    if gCurrentTopic = "parks" then
      set vArg to gDemoDir & "\parks\parks.iw"
      set vProg to gDemoDir & "\present\present.exe"
    else
      if gCurrentTopic = "cookbook" then
        set vArg to gDemoDir & "\ckbook\ckbook.iw"
        set vProg to gDemoDir & "\present\present.exe"
      else
        if gCurrentTopic = "astro" then
          set vArg to gDemoDir & "\astrosrc\astro.tbk"
          set vProg to gDemoDir & "\tbook\tbook.exe"
        else
          if gCurrentTopic = "space" then
            set vArg to gDemoDir & "\space\master\space.iw"
            set vProg to gDemoDir & "\present\present.exe"
          else
            if gCurrentTopic = "planets" then
              set vArg to gDemoDir & "\planets\planets.iw"
              set vProg to gDemoDir & "\present\present.exe"
            else
              if gCurrentTopic = "oz" then
                set vArg to EMPTY
                set vProg to gDemoDir & "\oz\oz.exe"
              else
                if gCurrentTopic = "dandy" then
                  set vArg to EMPTY
                  set vProg to gDemoDir & "\dndydino\dandy.exe"
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  set vFrameNo to the frame - 1
  go(vFrameNo)
  set vPlaceMark to the frameLabel
  set vCmd to gRouterName && vProg && vArg && vPlaceMark
  go("samplerExit")
  put vCmd
  open(vCmd)
  quit()
end
